#cs
	By: Matwachich, Inspired from Florian 'Piccaso' Fida (CoProc.au3)

	Simplified CoProc UDF

	Availble Functions:
		_CoProc($sCommande, $sReceiverFunc = "")
		_CoProc_SetReceiveFunc($sFunc = "", $iDelay = 100)
			(Receiver function: _Recv($iPID, $sReceived))
		_CoProc_CaptureStd($iPID, $iFlag = 1)
		_CoProc_VarSet($sName, $Value = Default)
		_CoProc_VarGet($sName)
		_CoProc_Pause($iPID)
		_CoProc_Resume($iPID)
		_CoProc_SendMsg($msg)

	WARNING: If you use in your thread some function in some Include, this
		include MUST BE BEFOR #Include <Thread.au3>
#ce

#include <Array.au3>
#include <File.au3>

#include "Messages.au3"
#include "SelfDelete.au3"

Global $__CoProc_RandomString = @AutoItPid & "RandomString"
Global $gs_CoProcReciverFunction = ""
Global $gi_CoProcParent = 0
Global $__CoProc_PIDArray[1]
	$__CoProc_PIDArray[0] = 0

; ##############################################################
If StringInStr($CmdLineRaw, "/thd") Then
	__CoProcStartup()
EndiF

; # FUNCTION # ==============================================================================================
; Name...........:	_CoProc
; Description....:	Lance un processus parallle, excutant la commande $sCommande
; Parameters.....:	$sCommande = Commande  executer (syntax de Execute)
;					$sReceiverFunc = Fonction appel lorsque le thread envoi un message.
;						elle doit tre de forme: _Func($iPid, $sMsg)
;						$iPid - Sera le PID du thread
;						$sMsg - Sera le message envoy par le thread
;					$iCopy - Spcifie si le thread doit tre le script lui mme ou une copie temporarite
; Return values..:	PID du nouveau thread
; Author.........:
; Remarks........:
; ===========================================================================================================
Func _CoProc($sCommande, $sReceiverFunc = "", $iCopy = 0)
	Local $iPid, $sTmpFile = _TempFile()
	If $sReceiverFunc <> "" Then _CoProc_SetReceiveFunc($sReceiverFunc)
	EnvSet("CoProc", "0x" & Hex(StringToBinary($sCommande)))
	EnvSet("CoProcParent", StringToBinary(@AutoItPID))
	If @Compiled Then
		If Not $iCopy Then
			$iPid = Run(FileGetShortName(@AutoItExe) & " /thd", @WorkingDir, @SW_HIDE, 2 + 4)
		Else
			FileCopy(@ScriptFullPath, $sTmpFile, 9)
			$iPid = Run(FileGetShortName($sTmpFile) & " /thd /sd", @WorkingDir, @SW_HIDE, 2 + 4) ; /se => SelfDelete
		EndIf
	Else
		$iPid = Run(FileGetShortName(@AutoItExe) & ' "' & @ScriptFullPath & '" /thd', @WorkingDir, @SW_HIDE, 2 + 4)
	EndIf
	If @error Then SetError(1)
	Return $iPid
EndFunc   ;==>_CoProc

; # FUNCTION # ==============================================================================================
; Name...........:	_CoProc_SetReceiveFunc
; Description....:	Change la fonction appel lors de la rception d'un message d'un thread
; Parameters.....:	$sFunc - Fonction  appeler, doit tre de mme forme que dans _CoProc
;					$iDelay - Delai de vrification des messages (AdlibRegister)
; Return values..:	1
; Author.........:
; Remarks........:
; ===========================================================================================================
Func _CoProc_SetReceiveFunc($sFunc = "", $iDelay = 100)
	If $sFunc <> "" Then
		$gs_CoProcReciverFunction = $sFunc
		_MsgRegister($__CoProc_RandomString, "__CoProc_ReceiveCheck")
		_MsgTimerInterval($iDelay)
		;AdLibRegister("__CoProc_ReceiveCheck", $iDelay)
	Else
		$gs_CoProcReciverFunction = ""
		_MsgRegister($__CoProc_RandomString, "")
		;AdLibUnRegister("__CoProc_ReceiveCheck")
	EndIf
	Return 1
EndFunc

; # FUNCTION # ==============================================================================================
; Name...........:	_CoProc_CaptureStd
; Description....:	Active/Desactive la capture de la sortie STD d'un thread.
; Parameters.....:	$iPID - PID du thread
;					$iFlag - 1 = active, 0 = desactiv
; Return values..:	1
; Author.........:
; Remarks........:	Quand la capture est activ, si une fonction thread fait appel a ConsoleWrite,
;					le texte s'affichera dans la console du script pre.
; ===========================================================================================================
Func _CoProc_CaptureStd($iPID, $iFlag = 1)
	If $iFlag Then
		_ArrayAdd($__CoProc_PIDArray, $iPID)
		$__CoProc_PIDArray[0] += 1
		Return AdLibRegister("__CoProc_ProcessStd", 10)
	Else
		Local $index
		For $i = 1 To $__CoProc_PIDArray[0]
			If $__CoProc_PIDArray[$i] = $iPID Then
				$index = $i
				ExitLoop
			EndIf
		Next
		; ---
		_ArrayDelete($__CoProc_PIDArray, $index)
		If Not IsArray($__CoProc_PIDArray) Then
			Global $__CoProc_PIDArray[1]
				$__CoProc_PIDArray[0] = 0
		EndIf
		; ---
		$__CoProc_PIDArray[0] -= 1
		If $__CoProc_PIDArray[0] < 0 Then $__CoProc_PIDArray[0] = 0
		; ---
		If $__CoProc_PIDArray[0] = 0 Then
			Return AdLibUnregister("__CoProc_ProcessStd")
		Else
			Return 1
		EndIf
	EndIf
EndFunc

; # FUNCTION # ==============================================================================================
; Name...........:	_CoProc_VarSet
; Description....:	Dclare une variable globale accssible par tous les threads
; Parameters.....:	$sName - Nom de la variable
;					$Value - Valeur de la variable
; Return values..:	Succes - <> 0 | Failed = 0
; Author.........:
; Remarks........:
; ===========================================================================================================
Func _CoProc_VarSet($sName, $Value)
	Return EnvSet("__CoProc_Var_" & $sName, $Value)
EndFunc

; # FUNCTION # ==============================================================================================
; Name...........:	_CoProc_VarGet
; Description....:	Retourne la valeur d'une variable globale
; Parameters.....:	$sName - Nom de la variable
; Return values..:	Succes - Valeur de la variable | Failed - 0 et @error = 1
; Author.........:
; Remarks........:
; ===========================================================================================================
Func _CoProc_VarGet($sName)
	Local $ret = EnvGet("__CoProc_Var_" & $sName)
	If $ret = "" Then Return SetError(1, 0, 0)
	Return SetError(0, 0, $ret)
EndFunc

; # FUNCTION # ================================================================================================
; Name...........:	_CoProc_Pause
; Description....:	Met un thread en pause
; Parameters.....:	$iPID - PID du thread
; Return values..:
; Author.........:
; Remarks........:
; ===========================================================================================================
Func _CoProc_Pause($iPID)
	Local $fRval = _ProcSuspend($iPID, False)
	Return SetError(@error, @extended, $fRval)
EndFunc

; # FUNCTION # ================================================================================================
; Name...........:	_CoProc_Resume
; Description....:	Reprend un thread suspendu
; Parameters.....:	$iPID - PID du thread
; Return values..:
; Author.........:
; Remarks........:
; ===========================================================================================================
Func _CoProc_Resume($iPID)
	Local $fRval = _ProcSuspend($iPID, True)
	Return SetError(@error, @extended, $fRval)
EndFunc

; # FUNCTION # ==============================================================================================
; Name...........:	_CoProc_SendMsg
; Description....:	Utilis par un thread pour envoyer un mssage au processus parent
; Parameters.....:	$msg - Message  envoyer au script pre
; Return values..:
; Author.........:
; Remarks........:
; ===========================================================================================================
Func _CoProc_SendMsg($msg)
	If _IsReceiver($__CoProc_RandomString) Then
		Return _MsgSend($__CoProc_RandomString, @AutoItPid & Chr(29) & $msg)
	Else
		Return SetError(1, 0, 0)
	EndIf
EndFunc

; ==============================================================
; ### Internals
; ==============================================================
Func __CoProc_ReceiveCheck($sReceived)
	If Not $gs_CoProcReciverFunction Then Return
	; ---
	Local $pid, $string
	$pid = StringLeft($sReceived, StringInStr($sReceived, Chr(29), 1, 1) - 1)
	$string = StringTrimLeft($sReceived, StringInStr($sReceived, Chr(29), 1, 1))
	Call($gs_CoProcReciverFunction, $pid, $string)
	; ---
	Return 0
EndFunc

Func __CoProc_ProcessStd()
	Local $read
	For $i = 1 To $__CoProc_PIDArray[0]
		$read = StdOutRead($__CoProc_PIDArray[$i])
		If Not @error Then
			If $read <> "" Then
				ConsoleWrite($read)
			EndIf
		Else
			_CoProc_CaptureStd($__CoProc_PIDArray[$i], 0)
		EndIf
	Next
EndFunc

Func __CoProcStartup()
	Local $aArgs, $ret
	Local $sCmd = EnvGet("CoProc")
	$gi_CoProcParent = BinaryToString(EnvGet("CoProcParent"))
	$__CoProc_RandomString = $gi_CoProcParent & "RandomString"
	If StringLeft($sCmd, 2) = "0x" Then
		$sCmd = BinaryToString($sCmd)
		$ret = Execute($sCmd)
		_CoProc_SendMsg($ret)
		If StringInStr($CmdLineRaw, "/sd") Then _SelfDelete()
		Exit
	EndIf
EndFunc   ;==>__CoProcStartup


;===============================================================================
;
; Description:      Suspend all Threads in a Process
; Parameter(s):     $vProcess - Name or PID of Process
; Requirement(s):   3.1.1.130, Win ME/2k/XP
; Return Value(s):  On Success - Returns Nr. of Threads Suspended and Set @extended to Nr. of Threads Processed
;                   On Failure - Returns False and Set
;												@error to:	1 - Process not Found
;															2 - Error Calling 'CreateToolhelp32Snapshot'
;															3 - Error Calling 'Thread32First'
;															4 - Error Calling 'Thread32Next'
;															5 - Not all Threads Processed
; Author(s):        Florian 'Piccaso' Fida
; Note(s):			Ported from: http://www.codeproject.com/threads/pausep.asp
;					Better read the article (and the warnings!) if you want to use it :)
;
;===============================================================================
Func _ProcSuspend($vProcess, $iReserved = 0)
	Local $iPid, $vTmp, $hThreadSnap, $ThreadEntry32, $iThreadID, $hThread, $iThreadCnt, $iThreadCntSuccess, $sFunction
	Local $TH32CS_SNAPTHREAD = 0x00000004
	Local $INVALID_HANDLE_VALUE = 0xFFFFFFFF
	Local $THREAD_SUSPEND_RESUME = 0x0002
	Local $THREADENTRY32_StructDef = _
			  "int;" _ ; 1 -> dwSize
			& "int;" _ ; 2 -> cntUsage
			& "int;" _ ; 3 -> th32ThreadID
			& "int;" _ ; 4 -> th32OwnerProcessID
			& "int;" _ ; 5 -> tpBasePri
			& "int;" _ ; 6 -> tpDeltaPri
			& "int"    ; 7 -> dwFlags
	$iPid = ProcessExists($vProcess)
	If Not $iPid Then Return SetError(1, 0, False) ; Process not found.
	Local $DLL = DllOpen("kernel32.dll")
	$vTmp = DllCall($DLL, "ptr", "CreateToolhelp32Snapshot", "int", $TH32CS_SNAPTHREAD, "int", 0)
	If @error Then
		DllClose($DLL)
		Return SetError(2, 0, False) ; CreateToolhelp32Snapshot Failed
	EndIf
	If $vTmp[0] = $INVALID_HANDLE_VALUE Then
		DllClose($DLL)
		Return SetError(2, 0, False) ; CreateToolhelp32Snapshot Failed
	EndIf
	$hThreadSnap = $vTmp[0]
	$ThreadEntry32 = DllStructCreate($THREADENTRY32_StructDef)
	DllStructSetData($ThreadEntry32, 1, DllStructGetSize($ThreadEntry32))
	$vTmp = DllCall($DLL, "int", "Thread32First", "ptr", $hThreadSnap, "long", DllStructGetPtr($ThreadEntry32))
	If @error Then
		DllClose($DLL)
		Return SetError(3, 0, False) ; Thread32First Failed
	EndIf
	If Not $vTmp[0] Then
		DllCall($DLL, "int", "CloseHandle", "ptr", $hThreadSnap)
		DllClose($DLL)
		Return SetError(3, 0, False) ; Thread32First Failed
	EndIf
	While 1
		If DllStructGetData($ThreadEntry32, 4) = $iPid Then
			$iThreadID = DllStructGetData($ThreadEntry32, 3)
			$vTmp = DllCall($DLL, "ptr", "OpenThread", "int", $THREAD_SUSPEND_RESUME, "int", False, "int", $iThreadID)
			If Not @error Then
				$hThread = $vTmp[0]
				If $hThread Then
					If $iReserved Then
						$sFunction = "ResumeThread"
					Else
						$sFunction = "SuspendThread"
					EndIf
					$vTmp = DllCall($DLL, "int", $sFunction, "ptr", $hThread)
					If $vTmp[0] <> -1 Then $iThreadCntSuccess += 1
					DllCall($DLL, "int", "CloseHandle", "ptr", $hThread)
				EndIf
			EndIf
			$iThreadCnt += 1
		EndIf
		$vTmp = DllCall("kernel32", "int", "Thread32Next", "ptr", $hThreadSnap, "long", DllStructGetPtr($ThreadEntry32))
		If @error Then
			DllClose($DLL)
			Return SetError(4, 0, False) ; Thread32Next Failed
		EndIf
		If Not $vTmp[0] Then ExitLoop
	WEnd
	DllCall($DLL, "int", "CloseToolhelp32Snapshot", "ptr", $hThreadSnap) ; CloseHandle
	If Not $iThreadCntSuccess Or $iThreadCnt > $iThreadCntSuccess Then Return SetError(5, $iThreadCnt, $iThreadCntSuccess)
	DllClose($DLL)
	Return SetError(0, $iThreadCnt, $iThreadCntSuccess)
EndFunc   ;==>_ProcSuspend
