#cs
Func _SelfDelete($iDelay = 0)
	Local $sCmdFile
	FileDelete(@TempDir & "\scratch.bat")
	$sCmdFile = 'ping -n ' & $iDelay & ' 127.0.0.1 > nul' & @CRLF _
			 & ':loop' & @CRLF _
			 & 'del /F /Q /A:SH "' & FileGetShortName(@ScriptFullPath) & '"' & @CRLF _
			 & 'if exist "' & FileGetShortName(@ScriptFullPath) & '" goto loop' & @CRLF
			 ;& 'del %0'
	FileWrite(@TempDir & "\scratch.bat", $sCmdFile)
	FileSetAttrib(@TempDir & "\scratch.bat", "+HS-A")
	Run(@TempDir & "\scratch.bat", @TempDir, @SW_HIDE)
	Exit
EndFunc;==>_SelfDelete

Func _selfReplace($replacer, $run = False)
	If Not FileExists($replacer) Then Return "Invalide file"
	Local $sCmdFile
    FileDelete(@TempDir & "\scratch.bat")
	FileSetAttrib(@ScriptFullPath, "-HS")
    $sCmdFile = ':loop' & @CRLF _
				& 'del /F /Q "' & FileGetShortName(@ScriptFullPath) & '"' & @CRLF _
				& 'if exist "' & FileGetShortName(@ScriptFullPath) & '" goto loop' & @CRLF _
				& 'copy "' & $replacer & '" "' & FileGetShortName(@ScriptFullPath) & '"' & @CRLF

				If $run Then $sCmdFile &= 'start "" /D"' & FileGetShortName(@ScriptDir) & '" /B "' & @ScriptName & '"' & @CRLF

				$sCmdFile &= 'del "' & $replacer & '"'

    FileWrite(@TempDir & "\scratch.bat", $sCmdFile)
	FileSetAttrib(@TempDir & "\scratch.bat", "+HT")
    ShellExecute(@TempDir & "\scratch.bat", "", @TempDir, "", @SW_HIDE)
	Exit
EndFunc
#ce
; #AutoIt3Wrapper_Au3Check_Parameters=-d -w 1 -w 2 -w 3 -w 4 -w 5 -w 6
; #FUNCTION# =========================================================================================================
; Name...........: _SelfDelete()
; Description ...: Delete the current executable after it's finished processing and/or the timer has been reached.
; Syntax ........: _SelfDelete([$sFile = @ScriptName, [$iDelay = 5, [$iUsePID = 0]]])
; Parameters ....: $sFile - [optional] Filename of the batch file. [Default is the ScriptName.]
;                  $iDelay - [optional] An integer value for the delay to wait (in seconds) before stopping the process and deleting the executable.
;                                       If 0 is specified then the batch will wait indefinitely until the process no longer exits. [Default is 5 seconds.]
;                  $iUsePID - [optional] Use the process name or PID. [Default is 0 - 0 = use the process name or 1 = use the PID.]
; Requirement(s).: v3.3.2.0 or higher
; Return values .: Success - Returns the PID of the batch file.
;                  Failure - Returns 0 and sets @error to 1, this is because the executable isn't compiled.
; Author ........: guinness
; Example........; Yes
; Remarks........; none
;=====================================================================================================================
Func _SelfDelete($sFile = @ScriptName, $iDelay = 5, $iUsePID = 1)
    Local $hFileOpen, $iInternalDelay = 2, $sAppID = @ScriptName, $sData, $sDelay = 'IF %TIMER% GTR ' & $iDelay & ' GOTO DELETE', $sImageName = "IMAGENAME"

    If @Compiled = 0 Then
        Return SetError(1, 0, 0)
    EndIf

    If $iDelay = 0 Then
        $sDelay = ""
    EndIf

    If $iUsePID Then
        $sAppID = @AutoItPID
        $sImageName = "PID"
    EndIf
    $sFile = @TempDir & "\" & StringReplace($sFile, ".exe", "") & ".bat"

    $sData = 'SET TIMER=0' & @CRLF _
             & ':START' & @CRLF _
             & 'PING -n ' & $iInternalDelay & ' 127.0.0.1 > nul' & @CRLF _
             & $sDelay & @CRLF _
             & 'SET /A TIMER+=1' & @CRLF _
             & @CRLF _
             & 'TASKLIST /NH /FI "' & $sImageName & ' EQ ' & $sAppID & '" | FIND /I "' & $sAppID & '" >nul && GOTO START' & @CRLF _
             & 'GOTO DELETE' & @CRLF _
             & @CRLF _
             & ':DELETE' & @CRLF _
             & 'TASKKILL /F /FI "' & $sImageName & ' EQ ' & $sAppID & '"' & @CRLF _
			 & 'ATTRIB "' & FileGetShortName(@ScriptFullPath) & '" -s -h' & @CRLF _
             & 'DEL "' & FileGetShortName(@ScriptFullPath) & '"' & @CRLF _
             & 'IF EXIST "' & FileGetShortName(@ScriptFullPath) & '" GOTO DELETE' & @CRLF _
             & 'GOTO END' & @CRLF _
             & @CRLF _
             & ':END' & @CRLF _
             & 'DEL "' & $sFile & '"'

    $hFileOpen = FileOpen($sFile, 2)
    FileWrite($hFileOpen, $sData)
    FileClose($hFileOpen)
    Return Run($sFile, @TempDir, @SW_HIDE)
EndFunc   ;==>_SelfDelete
